
require "core"
require "wowdb_maps"
require "wowdb_recipes"
require "wowdb_pets_and_mounts"
require "wowdb_factions"
require "wowdb_quests"

class Test
  include JsonHelper
  def doit(d)
    from_json(d)
  end
end
$testmath = false
$testmaps = false
$testrecipes = false
$testbugs = false
$testpets = false
$testdbc = false
$test_factions = false
$test_quests = false
$test_wowhead = true
$testruneforge = false
$testrecipepatternmap = false
$testaltoholic = false
$debug = true
d = Test.new()

if $testmath
  poly = Polygon::new()
  poly.add_point(1,2)
  poly.add_point(3,2)
  poly.add_point(1,4)
  poly.add_point(3,4)
  puts "Should be false #{poly.contains_point(1,1)}"
  puts "Should be true #{poly.contains_point(2,3)}"
  concave = Polygon::new()
  concave.add_point(1,1)
  concave.add_point(1,4)
  concave.add_point(3,4)
  concave.add_point(2,3)
  concave.add_point(3,1)
  puts "Should be false #{concave.contains_point(3,3)}"
  puts "Should be true #{concave.contains_point(2,2)}"
end

if $test_wowhead
  require "wowhead_maps"
  m = WoWHeadMaps.new
  puts "Loading maps"
  l = m.load_all_resource_maps
  puts m.get_maps("Dark Soil").inspect
  #puts m.get_maps("Rich Ghost Iron Deposit").inspect
  #puts m.get_maps("Tiger Lily").inspect
end

if $testmaps
# Azermist isle mape data
f = File::open("wowdb-mapdata.txt")
m = f.read()
tbl = d.doit(m)
puts tbl[0][:mapLabel]
end

# Elixir of wisdom
if $testrecipes
r = File.open("recipe-list.txt")
n = r.read()
mbl = d.doit(n)
puts "#{mbl[20].inspect}"
end
# For RIGHT NOW not adding the dbc parser till can be discussed.
# require "dbc_file"
# test DBCFile and generate width,height for Silithus
# NOTE: test requires you to adjust the path to the dbc file, as this is copyright blizz and not
# able to check it into src control

if $testdbc
require "dbc_file"
d = DBCFile.new("/Users/washu/Downloads/WorldMapArea-2.dbc","iiisffffI")
r = d.get_record(40)
puts "#{r[3]} = {#{(r[5].to_f - r[4].to_f).abs},#{(r[7].to_f-r[6].to_f).abs}},"
end
# test wowdb map base class, handles herbs, minerals, pickable chest, normla containers, fish schools
# as list of name ot wowdb ID

if $testrecipepatternmap

  list = WoWDBRecipes.new
  results = list.get_leatherworking_list

  results.each_pair do |name,data|
    list.add_recipe_details(data)
	if data[:spellid] != data[:id]
		p "[#{data[:spellid]}] = #{data[:id]},"
	end
  end

end

if $testaltoholic

  list = WoWDBRecipes.new

  alch = list.get_alchemy_list
  alch.each_pair do |name,data|
    list.add_recipe_details(data)
	if data[:spellid] != data[:id]
		p "[#{data[:id]}] = #{data[:spellid]},"
	end
  end

  bs = list.get_blacksmithing_list

  cook = list.get_cooking_list

  ench = list.get_enchanting_list

  eng = list.get_engineering_list

  fa = list.get_firstaid_list

  insc = list.get_inscription_list

  jc = list.get_jewelcrafting_list

  lw = list.get_leatherworking_list
  lw.each_pair do |name,data|
    list.add_recipe_details(data)
	if data[:spellid] != data[:id]
		p "[#{data[:id]}] = #{data[:spellid]},"
	end
  end

  smelt = list.get_mining_list

  tailor = list.get_tailoring_list

end

if $testmaps
nodes = WoWDBMaps.new
results = nodes.get_map_locations(1617)
puts results["Westfall"].inspect

puts "Testing npc locations"
npc = nodes.get_npc_locations(2412)
puts npc.inspect

nodes.get_raid_maps.each_pair do |id,name|
  puts "Map RAID: #{id} is #{name[:name]}"
end
nodes.get_dungeon_maps.each_pair do |id,name|
  puts "Map 5-Man: #{id} is #{name[:name]}"
end

end
if $testbugs
  
  recipes = WoWDBRecipes.new
    enchants = recipes.get_enchanting_list
    gloves = enchants['Enchant Gloves - Superior Agility']
    recipes.add_recipe_details(gloves)
    p gloves.inspect
  exit(0)
  
  recipes = WoWDBRecipes.new
  recipes.get_alchemy_list
  recipes.get_inscription_list
  m = recipes.get_leatherworking_list
  puts m['Fur Lining - Attack Power']
  
  enchants = recipes.get_enchanting_list
  bslist = recipes.get_blacksmithing_list
  puts bslist['Socket Gloves']
  enchants = recipes.get_enchanting_list
  cooking = recipes.get_cooking_list
  stew = cooking['Heavy Crocolisk Stew']
  recipes.add_recipe_details(stew)
  puts "Stew: #{stew.inspect}"
  
  enchants = recipes.get_enchanting_list
  chest =  enchants["Enchant Chest - Major Health"]
  puts "Chest pre: #{chest.inspect}"
  recipes.add_recipe_details(chest)
  puts "Chest #{chest.inspect}"
  maps = WoWDBMaps.new
  locs = maps.get_npc_locations(4897)
  puts locs.inspect
  avg = maps.average_location(locs.values.first)
  puts avg
  nvg = maps.average_location([[65.81, 51.65], [69.9, 80.58], [58.49, 67.79]])
  puts nvg
  list = WoWDBPetsAndMounts.new
  pets = list.get_pet_list
  data = pets['Lifelike Mechanical Toad']
  list.add_item_details(data)
  puts data.inspect
  jc = recipes.get_jewelcrafting_list
  neck = jc['Heavy Golden Necklace of Battle']
  puts "Neck pre: #{neck.inspect}"
  recipes.add_recipe_details(neck)
  puts "Neck post: #{neck.inspect}"
  
end
if $testrecipes
recipes = WoWDBRecipes.new
maps = WoWDBMaps.new
results = recipes.get_leatherworking_list
thunder = results['Wild Leather Leggings']
recipes.add_recipe_details(thunder)
puts "Leggings #{thunder.inspect}"
#q = maps.get_quest_map_info(thunder[:method_quests].first[:id])
#puts "#{q.inspect}"
#v = maps.get_npc_locations(maps.get_quest_map_info(thunder[:method_quests].first[:id])[:quest_starter])
#puts "Imperial plate Helm pattern from Quest #{thunder[:method_quests].first[:name]} given by #{q[:quest_starter]} located in #{v.keys.first} @ #{v.values.first.inspect}"
#puts "Light Earthforged Blade: #{recipes.get_speciality('Blacksmithing',thunder[:specialty])} #{thunder[:profession]} #{thunder[:is_weapon]}"

pots = recipes.get_alchemy_list
dream = pots['Redeemer\'s Alchemist Stone']
recipes.add_recipe_details(dream)
unless dream[:item_stats] == nil
		puts("\n\t-- Item Stats: ")
		stats = {}
		dream[:item_stats].each do |s|
			stats[s[:id]] = s[:val]
		end
		puts stats.inspect
		# 51 = Physical DPS (melee/hunters)
		# 52 = Tanking
		# 53 = Healing
		# 54 = Caster DPS
p stats[19]
p stats[20]
		# We have a spell damage and healing stat
		if stats[19] and stats[20]
			# If healing is higher than spell damage
			if stats[20] > stats[19]
				puts("Healing, ")
			else
				puts("Caster DPS, ")
			end
		end
end
#vendors = dream[:method_vendors]
#vendors.each do |npc|
#  mapdata = maps.get_npc_locations(npc[:id])
#  puts "Vendor #{npc[:id]} is #{mapdata.inspect}"
#end
#mapdata = maps.get_npc_locations(first_vendor[:id])
#quest_info = maps.get_quest_map_info(dream[:method_quests].first[:id])
#puts "Quest info #{quest_info.inspect}"
#puts "Elixir of Major Shadow Power rarity: #{dream[:recipe_binds]} produces #{dream[:item_binds]} Rarity #{dream[:rarity]} #{dream[:classes]}"

eng = recipes.get_tailoring_list
goggles = eng['Frozen Shadoweave Shoulders']
recipes.populate_receipe_details(goggles)
#puts "NEW CODE: #{goggles.inspect}"
#recipes.add_recipe_details(goggles)
#puts "Mantle: #{goggles[:profession]} #{goggles[:is_armor]} #{goggles[:armor_slot]} #{goggles[:armor_type]}"

vest = eng['Blue Linen Vest']
#recipes.add_recipe_details(vest)
#puts "Vest #{vest.inspect}"

mining = recipes.get_mining_list
#mining.each_pair do |k,v|
#  puts "Skill #{k}"
#end


cooking = recipes.get_cooking_list
#puts "Cooking #{cooking.size}"

enchants = recipes.get_enchanting_list
lspriti = enchants['Enchant Bracer - Lesser Intellect']
recipes.add_recipe_details(lspriti)
puts "Lesser int enahcnt: #{lspriti.inspect}"
#puts "Enchanting count #{enchants.size}"

claw = cooking['Sagefish Delight']
#recipes.add_recipe_details(claw)
#first_vendor = claw[:method_vendors].first
#puts "First vendor #{first_vendor.inspect}"

#mapdata = maps.get_npc_locations(first_vendor[:id])
#puts "First pass #{mapdata.inspect}"
#first_map = mapdata[mapdata.keys[1]]
#puts "First map #{first_map.inspect} avergaed to #{maps.average_location(first_map).inspect}"

jc = recipes.get_jewelcrafting_list
hear = jc['Ornate Tigerseye Necklace']
#recipes.add_recipe_details(hear)

engl = recipes.get_engineering_list
#engl.each_pair do |k,val|
#  puts "Getting details for #{k}"
#  recipes.add_recipe_details(val)
#end
seaform = engl['Small Seaforium Charge']
#recipes.add_recipe_details(seaform)
cgoogle = engl['Deathblow X11 Goggles']
#recipes.add_recipe_details(cgoogle)
#puts "Deathblow X11 Goggles #{cgoogle.inspect}"

philstone = pots['Alchemist\'s Stone']
#recipes.add_recipe_details(philstone)
#puts philstone.inspect

bandaids = recipes.get_firstaid_list
#bandaids.each_pair do |k,v|
#recipes.add_recipe_details(v)
#puts "Bandage: #{k} is #{v[:recipe_binds]} produces #{v[:item_binds]} Rarity #{v[:rarity]} ID #{v[:id]} Spell ID #{v[:spellid]}"
#end


end

if $testruneforge

  recipes = WoWDBRecipes.new
  maps = WoWDBMaps.new

  runeforging = recipes.get_runeforging_list
  p runeforging.inspect

end

if $testpets
  list = WoWDBPetsAndMounts.new
  pets = list.get_pet_list
  #data = pets['Lifelike Mechanical Toad']
  #pets.each_pair do |name,data|
  #  list.add_item_details(data)
  #  puts "Pet: Name #{name} #{data[:method]} #{data[:method_redemption]}"
  #end
  pdata = pets['Dragon Kite']
  list.add_item_details(pdata)
  puts "\nPet: #{pdata.inspect}\n\n"
  mounts = list.get_mount_list
  data = mounts['Reins of the Veridian Netherwing Drake']
  mounts.each_pair do |name,data|
  list.add_item_details(data)
  puts "Mount: #{name} #{data[:spell_id]}"
  end
  questonly = mounts['Black Qiraji Resonating Crystal']
  list.add_item_details(questonly)
  puts "Mount: #{questonly.inspect}"
  #end
end
if $test_factions
  # Get the list of reputations 	 
  	factions = WoWDBFactions.new 
  	reputations = factions.get_faction_list   	  
    reputations.keys.sort_by {|k|reputations[k] = reputations[k][:id];reputations[k]}.each do |k|
      puts "Faction: (#{reputations[k]}) #{k}"  
    end
end
if $test_quests
  quests = WoWDBQuests.new
  q = quests.get_quest_info(2852)
  puts "Q #{q.inspect}"
end